﻿<div style="height: 85px">
    <div class="demo-section k-header">
        <form enctype="multipart/form-data">
            <input name="files" id="TriSysUploadFiles" type="file" />
        </form>
    </div>
</div>

<div class="TriSys-ShowMessage-Footer">

    <div class="TriSys-ShowMessage-Button3rdWidth">

        <button id="buttonSave" class="k-button k-state-default" style="width:65px"
                onclick="buttonSaveClick()" title="left">
            Save
        </button>

    </div>

    <div class="TriSys-ShowMessage-Button3rdWidth">

        &nbsp;

    </div>

    <div class="TriSys-ShowMessage-Button3rdWidth">

        <button id="buttonCancel" class="k-button k-state-default" style="width:65px"
                onclick="buttonCancelClick()" title="right">
            Cancel
        </button>

    </div>

</div>

<script type="text/javascript">
    $(document).ready(function ()
    {
        $("#TriSysUploadFiles").kendoUpload({
            async: {
                //saveUrl: "https://api.trisys.co.uk/files/uploadfile",
                //removeUrl: "remove",
                autoUpload: false,
                withCredentials: true
            },
            multiple: false,
            localization: {
                select: "Select a Local File",
                uploadSelectedFiles: "Upload"
            },
            select: onSelect,
            remove: onRemove,
            progress: onProgress,
            complete: onComplete,
            upload: onUpload,
            success: onSuccess,
            error: onError
        });

        function onRemove(e)
        {
            _UploadedFileRelativePath = null;
        }

        function onSelect(e)
        {
            TriSysApex.Logging.LogMessage("Select :: " + getFileInfo(e));

            var formData = new FormData();
            var trisysFile = $('#TriSysUploadFiles')[0];
            formData.append("trisysFile", trisysFile.files[0]);

            TriSysApex.UI.ShowWait(null, "Uploading File...");

            $.ajax({
                type: "POST",
                url: "https://api.trisys.co.uk/files/uploadfile",
                contentType: false,
                processData: false,
                data: formData,
                cache: false,
                crossDomain: true,
                beforeSend: function (xhr)
                {
                    xhr.setRequestHeader('SiteKey', TriSysAPI.Session.DeveloperSiteKey());

                    var sDataServicesKey = TriSysAPI.Session.DataServicesKey();
                    if (!TriSysAPI.Operators.isEmpty(sDataServicesKey))
                        xhr.setRequestHeader('DataServicesKey', sDataServicesKey);
                },
                success: function (result)
                {
                    _UploadedFileRelativePath = result[0];
                    TriSysApex.UI.HideWait();
                },

                error: function (request, status, error)
                {
                    TriSysApex.UI.HideWait();
                    TriSysApex.UI.ErrorHandlerRedirector("?", request, status, error);
                }
            });
        }
        function onComplete(e)
        {
            TriSysApex.Logging.LogMessage("Complete");
        }
        function onProgress(e)
        {
            TriSysApex.Logging.LogMessage("Upload progress :: " + e.percentComplete + "% :: " + getFileInfo(e));
        }
        function onSuccess(e)
        {
            TriSysApex.Logging.LogMessage("Success (" + e.operation + ") :: " + getFileInfo(e));
        }
        function onError(e)
        {
            TriSysApex.Logging.LogMessage("Error (" + e.operation + ") :: " + getFileInfo(e));
        }

        function getFileInfo(e)
        {
            return $.map(e.files, function (file)
            {
                var info = file.name;

                // File size is not available in all browsers
                if (file.size > 0)
                {
                    info += " (" + Math.ceil(file.size / 1024) + " KB)";
                }
                return info;
            }).join(", ");
        }

        function onUpload(e)
        {
            TriSysApex.Logging.LogMessage('onUpload');

            // Array with information about the uploaded files
            var files = e.files;

            // Check the extension of each file and abort the upload if it is not .jpg
            //$.each(files, function ()
            //{
            //    if (this.extension.toLowerCase() != ".jpg")
            //    {
            //        alert("Only .jpg files can be uploaded")
            //        e.preventDefault();
            //    }
            //});

            var xhr = e.XMLHttpRequest;
            if (xhr)
            {
                //State  Description
                //0      The request is not initialized
                //1      The request has been set up
                //2      The request has been sent
                //3      The request is in process
                //4      The request is complete
                xhr.addEventListener("readystatechange", function (e)
                {
                    TriSysApex.Logging.LogMessage('xhr.addEventListener("readystatechange", function (e) xhr.readyState=' + xhr.readyState);

                    if (xhr.readyState == 1 /* OPENED */)
                    {
                        TriSysApex.Logging.LogMessage("xhr.readyState == 1 /* OPENED */");

                        xhr.setRequestHeader('SiteKey', TriSysAPI.Session.DeveloperSiteKey());

                        var sDataServicesKey = TriSysAPI.Session.DataServicesKey();
                        if (!TriSysAPI.Operators.isEmpty(sDataServicesKey))
                            xhr.setRequestHeader('DataServicesKey', sDataServicesKey);

                        TriSysApex.Logging.LogMessage("Security headers completed.");
                    }
                });
            }
        }

    });

    var _UploadedFileRelativePath = null;

    function buttonSaveClick()
    {
        if (!_UploadedFileRelativePath)
        {
            TriSysApex.UI.Notifications.Error("No File", "Please choose a local file before uploading it.");
            return;
        }

        TriSysApex.UI.CloseTopmostModalPopup();
        TriSysSDK.Controls.FileManager.SaveCallbackFunction(_UploadedFileRelativePath);
    }

    function buttonCancelClick()
    {
        TriSysApex.UI.CloseTopmostModalPopup();
    }

</script>